library soundex;

uses
 sysutils,
  SMNameMatch,
  epiUDFTypes in 'epiUDFTypes.pas';



procedure NEWSOUNDEX(const ParamList:variant;var ReturnValue:variant);
var
 s :string;
 va : variant;
begin
 va :=VarArrayCreate([0,0],Varvariant);
 va := ParamList;
 s := va[0];
 s:=_SMSoundex(S);
 ReturnValue:=VarAsType(s,  varOleStr );
// ReturnValue:=s;
end;

procedure METAPHONE(const ParamList:variant;var ReturnValue:variant);
var
 s :string;
 va : variant;
begin
 va :=VarArrayCreate([0,0],Varvariant);
 va := ParamList;
 s := va[0];
 s:=_SMMetaphone(S);
 ReturnValue:=VarAsType(s,  varOleStr );
// ReturnValue:=s;
end;

procedure SMPOWER(const ParamList:variant;var ReturnValue:variant);
//function  SMPOWER(const ParamList:variant):variant; stdcall;
var
 va : variant;
 x :integer;
begin
 va :=VarArrayCreate([0,1],Varvariant);
 va := ParamList;
 x := va[0]*va[1];
 ReturnValue:=x;
end;

procedure SMTEST(const ParamList:variant;var ReturnValue:variant);
begin
   ReturnValue:= ParamList;
end;


function GetUDFCount:integer;
begin
  result:=2;
end;

procedure GetUDFInfo(Const UDFid:integer; var functionString:variant;var ReturnType:variant;
       var FunctionName:variant;var ParamCount:integer);
begin
case  UDFid of
1:
begin
  functionString:= VarAsType('NEWSOUNDEX',  varOleStr );
  ReturnType:=UDFReturnString;
  FunctionName:=VarAsType('NEWSOUNDEX',  varOleStr );
  ParamCount:=1;
end;
2:
begin
  functionString:=VarAsType('METAPHONE',  varOleStr );
  ReturnType:=UDFReturnString;
  FunctionName:=VarAsType('METAPHONE',  varOleStr );
  ParamCount:=1;
end;
end;
end;


exports NEWSOUNDEX index 1,
   SMPOWER index 2,
   SMTEST index 3,
   GetUDFCount index 4,
   GetUDFInfo index 5,
   METAPHONE index 6;

begin
end.
